<?php

/**
*  TargetPay SMS example class
* 
*  SVE
*  11-01-2009
*/
  
# requires the init class
require_once ( 'TargetPay.class.php' );
  
class TargetPaySms extends TargetPay {
   
  // default country set to NL code
  // NL: 31
  // BE: 32
  protected $countryCode = 0;
	
  # ofcourse construct
  public function __construct( $intRtlo ) {
    
    # call parent constructor 
    parent::__construct( $intRtlo );
      
  }
  
  /**
  * @Desc start payment
  * @Return array ( payline, paycode, price )
  * 
  * Response will look like: ( 3010, BETAAL AR, � 2 euro)
  */
  
  public function startPayment ($test) {
      
      try {
                    
          # Build parameter string
          $aParameters = $this->getBaseRequest();
          $aParameters['method'] = 'SMS';
          $aParameters['country'] = $this->countryCode;
          $aParameters['test'] = $test;
          if ( $this->SmsAmount > 0 ) $aParameters['smsamount'] = $this->SmsAmount; 

          # do request
          $strResponse = $this->getResponse( $aParameters );
          $aResponse = explode('|', $strResponse );

          # Bad response
          if ( !isset ( $aResponse[3] ) ) {
            throw new Exception( 'Error' . $aResponse[0] );    
          }
          
          # We return Payline, code, and price
          return array ( $aResponse[2], $aResponse[3], $aResponse[4] );
              
      } 
      catch( Exception $e ) {
      
        # error, could not proceed 
        echo $e->getMessage();
      
      }    
  }
  
  /**
   * Validate the payment now by trxId
   *
   * @return bool
   */
   
   public function validatePayment ( $strKeyword, $strPayCode, $strShortcode, $countryCode, $test ) {
       
       try {
        
           # Build parameter string
           $aParameters = $this->getBaseRequest();
           $aParameters['action'] = 'check';
           $aParameters['method'] = 'SMS';
           $aParameters['shortcode'] = $strShortcode;
           $aParameters['paycode'] = $strPayCode;
           $aParameters['keyword'] = $strKeyword;
           $aParameters['country'] = $countryCode;
           $aParameters['test'] = $test;
           
           # do request
           $strResponse = $this->getResponse ( $aParameters );
           $aResponse = explode('|', $strResponse );
           
           # Bad response
           if (  $aResponse[0] != 'OK' ) {
                throw new Exception( $aResponse[0] );    
           }
           
           return true;
       
       }    
       catch( Exception $e ) {
      
        # error, could not proceed 
        echo $e->getMessage();
      
      } 
               
   }
   
   public function setSmsAmount ( $intAmount ) {
       if ( is_numeric ( $intAmount ) && $intAmount > 0 )  {  
            $this->SmsAmount = $intAmount;
       }   
   }
   
   public function setCountryCode ( $intCountryCode ) {
   	$this->countryCode = $intCountryCode;
   }
}
  
?>
