<?php
/*
The following steps have to be carried out in order to generate and activate the acceptors own certificate and key pair:
1. Generate an RSA private key with the following command (use a self chosen password for the field ownPassword): openssl genrsa des3 out priv.pem passout pass:ownPassword 1024

2. The result of this is the priv.pem file. PEM files are intended for the storage of the private key and the public key. The file is saved as the default in the bin directory under the OpenSSL directory.

3. Generate a certificate on the basis of the RSA private key (use the same password for the field ownPassword as in step 2): openssl req x509 new key priv.pem passin pass:ownPassword days 3650 out cert.cer
This command leads to a series of questions about the requestor. Enter the correct values. This relates among other things to the organization name. You need this organization name in some subsequent steps.
The result is the cert.cer file. CER files contain the certificate and the public key. The file is saved as the default in the bin directory under the OpenSSL directory.

4. Copy the private key and the certificate to the same defined folder as the configuration file (see section 3.3).

5. Configure the following parameters in the config.conf file; replace the value for PrivatekeyPass in ownPassword that you also used in step 2:
Privatekey=priv.pem PrivatekeyPass=ownPassword Privatecert=cert.cer

6. Upload cert.cer to the test environment of the iDEAL Acquiring platform (via the iDEAL Dashboard).

7. After positive verification by the iDEAL Service Desk (see Chapter Registration process of the iDEAL General information document): Upload cert.cer to the production environment of the iDEAL Acquiring platform (via the iDEAL Dashboard).
Anugrah

*/

if ($vars['test']=='true') 			$ms['url']	='ssl://idealtest.rabobank.nl:443/ideal/iDeal';
else 								$ms['url']	='ssl://ideal.rabobank.nl:443/ideal/iDeal';
$validUntil							=date("Y-m-d\TH:i:s",(time()+3000)).':000Z';
$paymentType						='ideal';
$merchant_id						=$vars['merchant_id'];
$merchant_key						=$vars['merchant_key'];
$merchant_subid						=$vars['merchant_subid'];
$amount								=(preg_replace("/^0/",'',$order['total_amount'])*100);

// creating the hash step by step in an array so we can easily debug it if there is something wrong
$hash_array=array();
$hash_array[] 	= $merchant_key;
$hash_array[] 	= $merchant_id;
$hash_array[] 	= $merchant_subid;
$hash_array[] 	= $amount;
$hash_array[] 	= $order['orders_id'];
$hash_array[] 	= $paymentType;
$hash_array[] 	= $validUntil;
$orderid 		= $order['orders_id'];


# config file for iDEAL PHP thinMPI 

#Your Private Key file
$ideal_adv_config['Privatekey']			= 'priv.pem';
#Your Password for the Private Key
$ideal_adv_config['PrivatekeyPass']		= $vars['private_key_pass'];
#Your own certificate (to create fingerprint)
$ideal_adv_config['Privatecert']		= 'cert.cer';

#Put all trusted certificates of your acquirer here
#increase the number behind Certificate by one starting with 0. 
#There are up to 9 certificates allowed here all of them in the 
#security-subdirectory
$ideal_adv_config['Certificate0']		= 'ideal.cer';

#IP address and path of the server that gets the request
#This value contains the URL of the Rabo iDEAL acquirer
#For test and integration this value should be: ssl://idealtest.rabobank.nl:443/ideal/iDeal
#For production you must change this value to: ssl://ideal.rabobank.nl:443/ideal/iDeal
$ideal_adv_config['AcquirerURL']		= $ms['url'];
$ideal_adv_config['AcquirerTimeout']	= '120';

# The ID of the merchant. This ID will be given during the sign-in-process at the acquirer
$ideal_adv_config['MerchantID']			= $vars['merchant_id'];
# The SubID of the merchant. Normally this ID is 0. It will be given during the sign-in-process at the acquirer
$ideal_adv_config['SubID']				= $vars['merchant_subid'];
# The desired cryptography. Currently only SHA1_RSA is supported
$ideal_adv_config['AuthenticationType']	= 'SHA1_RSA';

# The URL the merchant should be redirected to after the payment.
$ideal_adv_config['MerchantReturnURL']	= $this->FULL_HTTP_URL.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl_ideal_rabobank_professional');
# The currency of the bill
$ideal_adv_config['Currency']			= $ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3'];
# The expiration period of the payment
$ideal_adv_config['ExpirationPeriod']	= 'PT60M';
# The language of the issuer screen, currently only nl is supported
$ideal_adv_config['Language']			= 'nl';
# the default description for the payment
$ideal_adv_config['DESCRIPTION']		= substr($ms['MODULES']['STORE_NAME'], 0, 15);
# The default EntranceCode
$ideal_adv_config['EntranceCode']		= '12345678';

require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_rabobank_professional/ThinMPI.php');


if (!$post['issuerID']) {
	require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_rabobank_professional/DirectoryRequest.php');
	require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_rabobank_professional/DirectoryResponse.php');

	$content .= '<form action="" method="post" name="pspform" id="pspform" target="'.($vars['open_in_new_window']=='true'?'_blank':'').'">
	<table width="80%">
	  <tr>
		<td align="right" colspan="1"><strong>Kies uw bank:</strong></td>
		<td colspan="5">';

	//Here comes the interesting part: the Directory Request itself.
	//Create a directory request
	$data = new DirectoryRequest();
	//Set parameters for directory request
	
	//Create thinMPI instance
	$rule = new ThinMPI($ideal_adv_config);

	//Process directory request
	$result = $rule->ProcessRequest($data);
	
	if(!$result->isOK())
	{
		$content .= "Er is op dit moment geen betaling met iDEAL mogelijk.<br>";
		$content .= "Foutmelding van iDEAL: ";
		$Msg = $result->getErrorMessage();
		$content .= "$Msg<br>";
	}
	else
	{
		//Get issuerlist
		$issuerArray = $result->getIssuerList();
		if(count($issuerArray) == 0)
		{
			$content .= "Lijst met banken niet beschikbaar, er is op dit moment geen betaling met iDEAL mogelijk.";
		}
		else
		{
			//Directory request succesful and at least 1 issuer
			
			for($i=0;$i<count($issuerArray);$i++)
			{
				if($issuerArray[$i]->issuerList == "Short")
				{
					$issuerArrayShort[]=$issuerArray[$i];
				}
				else
				{
					$issuerArrayLong[]=$issuerArray[$i];
				}
				
			}
    		//Create a selection list
			$content .= "<select name=\"issuerID\">";
		    $content .= "<option value=\"0\">Kies uw bank...</option>";
			//Create an option tag for every issuer
			for($i=0;$i<count($issuerArrayShort);$i++)
			{
				$content .= "<option value=\"{$issuerArrayShort[$i]->issuerID}\"> {$issuerArrayShort[$i]->issuerName} </option>";
			}
			if(count($issuerArrayLong) > 0)
			{
				$content .= "<option value=\"0\">---Overige banken---</option>";
			}
			for($i=0;$i<count($issuerArrayLong);$i++)
			{
				$content .= "<option value=\"{$issuerArrayLong[$i]->issuerID}\"> {$issuerArrayLong[$i]->issuerName} </option>";
			}
			$content .= "</select>";
		}
	}

	$content .= '<input type="submit" name="idealbutton" value="Klik hier om te betalen via iDEAL" />
	</td></tr></table>
	</form>';

} else {
	require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_rabobank_professional/AcquirerTrxRequest.php');
	
	//Show errors so we know if any PHP error occurs
	//include needed files

	//Put information from form in variables
	$orderNumber = $orderid;
	$issuerID = $post['issuerID'];
	if($issuerID==0)
	{
		$content .= "Kies uw bank uit de lijst om met iDEAL te betalen<br>";
		exit();
	}
	//Create TransactionRequest
	$data = new AcquirerTrxRequest();
	
	//Set parameters for TransactionRequest
	$data -> setIssuerID($issuerID);
	$data -> setPurchaseID($orderNumber);
	$data -> setAmount($amount);
	
	//Create ThinMPI instance
	$rule = new ThinMPI($ideal_adv_config);
	
	$result = new AcquirerTrxResponse();
	
	//Process Request
	$result = $rule->ProcessRequest( $data );
	
	
	if($result->isOK())
	{
		
		$transactionID = $result->getTransactionID();
		// here we go putting some transaction data to tx_multishop_payment_transactions
		$GLOBALS['TYPO3_DB']->sql_query("INSERT INTO tx_multishop_payment_transactions (orders_id, transaction_id, psp, crdate, status,code) VALUES ('".$orderid."', '".$transactionID."', 'ideal_rabobank_professional','".time()."', '0','".$user_method['code']."')");

		//Get IssuerURL en decode it
		$ISSURL = $result->getIssuerAuthenticationURL();
		$ISSURL = html_entity_decode($ISSURL);
	
		//Redirect the browser to the issuer URL
		header("Location: $ISSURL"); 
		exit();
	}
	else
	{
		//TransactionRequest failed, inform the consumer
		$content .= "Er is helaas iets misgegaan. Foutmelding van iDEAL:<br>";
		$Msg = $result->getErrorMessage();
		$content .= "$Msg<br>";
	}
}
